﻿function onPageLoad() {
    ExecuteOrDelayUntilScriptLoaded(function () {
        getWebHitCountAsync().done(function (hitCount) {
            displayHitCount(hitCount);

            if (!$.cookie('hitted')) {
                increaseWebHitCount().done(function () {
                    $.cookie('hitted', 'true');
                });
            }
        });
    }, 'SP.js');
}

function displayHitCount(hitCount) {
    $('<div style="text-align:left;padding-left:10px;margin-top:10px;display:none">网站计数器：' + hitCount + '</div>').appendTo('.ms-quickLaunch').slideDown('slow');
}

function getWebHitCountAsync() {
    return $.Deferred(function (dtd) {
        var ctx = SP.ClientContext.get_current();
        var web = ctx.get_web();
        var webProps = web.get_allProperties();
        ctx.load(webProps);
        ctx.executeQueryAsync(function () {
            var hitCount = webProps.get_fieldValues()['webHitCount'];
            if (!hitCount) {
                hitCount = 0;
            }
            dtd.resolve(hitCount);
        }, function () {
            dtd.reject(0);
        });
    }).promise();
}

function increaseWebHitCount() {
    return $.Deferred(function (dtd) {
        getWebHitCountAsync().done(function (hitCount) {
            var ctx = SP.ClientContext.get_current();
            var web = ctx.get_web();
            var webProps = web.get_allProperties();
            webProps.set_item('webHitCount', ++hitCount);
            web.update();
            ctx.executeQueryAsync(function () {
                dtd.resolve();
            }, function () {
                dtd.reject();
            });
        });        
    }).promise();
}

_spBodyOnLoadFunctionNames.push('onPageLoad');